-- $Id: periodic_workloads.ads,v 1.3 2008/11/20 18:49:43 baker Exp $

with Jobs;
with Virtual_Times; use Virtual_Times;
with Workload_Models;
package Periodic_Workloads is

   type Object is new Workload_Models.Object with private;

   type Parameters is record
      Period : Time;
      Deadline : Time;
      WCET : Time; --  worst-case execution time
   end record;

   procedure Bind_Parms (M : in out Object;
                         P : Parameters);

   procedure Arrive (M : in out Object;
                     T : in Time;
                     J : out Jobs.Job;
                     Next_Arrival_Time : out Time);

   function Start_Time (M : in Object) return Time;

   function Name (Model : Object) return String;

private

   type Object is new Workload_Models.Object with record
      Parms: Parameters;
   end record;

end Periodic_Workloads;
